/* Public domain. */

#ifndef CDB_H
#define CDB_H

#include "uint32.h"

#define CDB_HASHSTART 5381
extern u_int32_t cdb_hashadd(u_int32_t,unsigned char);
extern u_int32_t cdb_hash(const char *,unsigned int);

struct cdb {
  char *map; /* 0 if no map is available */
  int fd;
  u_int32_t size; /* initialized if map is nonzero */
  u_int32_t loop; /* number of hash slots searched under this key */
  u_int32_t khash; /* initialized if loop is nonzero */
  u_int32_t kpos; /* initialized if loop is nonzero */
  u_int32_t hpos; /* initialized if loop is nonzero */
  u_int32_t hslots; /* initialized if loop is nonzero */
  u_int32_t dpos; /* initialized if cdb_findnext() returns 1 */
  u_int32_t dlen; /* initialized if cdb_findnext() returns 1 */
} ;

extern void cdb_free(struct cdb *);
extern void cdb_init(struct cdb *,int fd);

extern int cdb_read(struct cdb *,char *,unsigned int,u_int32_t);

extern void cdb_findstart(struct cdb *);
extern int cdb_findnext(struct cdb *,const char *,unsigned int);
extern int cdb_find(struct cdb *,const char *,unsigned int);

#define cdb_datapos(c) ((c)->dpos)
#define cdb_datalen(c) ((c)->dlen)

#endif
